hpp-constraints: Tools

hpp-constraints 9.0.2 Definition of basic geometric constraints for motion planning

Loading...
Searching...
No Matches
Classes | Typedefs | Functions
Tools
Constraints
Collaboration diagram for Tools:

## Classes
struct | Eigen::BlockIndex
class | Eigen::MatrixBlockView< _ArgType, _Rows, _Cols, _allRows, _allCols >
class | Eigen::MatrixBlocks< _allRows, _allCols >
class | Eigen::MatrixBlocksBase< Derived >

## Typedefs
typedef Eigen::MatrixBlocks< false, true > | Eigen::RowBlockIndices
typedef Eigen::MatrixBlocks< true, false > | Eigen::ColBlockIndices

## Functions
template<typename Derived >
std::ostream & | Eigen::operator<< (std::ostream &os, const MatrixBlocksBase< Derived > &mbi)
template<typename Derived >
void | hpp::constraints::logSO3 (const matrix3_t &R, value_type &theta, Eigen::MatrixBase< Derived > const &result)
template<typename Derived >
void | hpp::constraints::JlogSO3 (const value_type &theta, const Eigen::MatrixBase< Derived > &log, matrix3_t &Jlog)
template<typename Derived >
void | hpp::constraints::logSE3 (const Transform3s &M, Eigen::MatrixBase< Derived > &result)
template<typename Derived >
void | hpp::constraints::JlogSE3 (const Transform3s &M, Eigen::MatrixBase< Derived > const &Jlog)
template<typename Derived1 , typename Derived2 >
void | hpp::constraints::matrixToQuat (const Eigen::MatrixBase< Derived1 > &M, Eigen::MatrixBase< Derived2 > const &q)
template<typename Derived >
void | hpp::constraints::se3ToConfig (const Transform3s &M, Eigen::MatrixBase< Derived > const &q)

## Detailed Description

## Typedef Documentation

## ◆ ColBlockIndices

typedef Eigen::MatrixBlocks<true, false> Eigen::ColBlockIndices

## ◆ RowBlockIndices

typedef Eigen::MatrixBlocks<false, true> Eigen::RowBlockIndices

## Function Documentation

## ◆ JlogSE3()

template<typename Derived >

void hpp::constraints::JlogSE3 | ( | const Transform3s & | M,
|  | Eigen::MatrixBase< Derived > const & | Jlog )

## ◆ JlogSO3()

template<typename Derived >

void hpp::constraints::JlogSO3 | ( | const value_type & | theta,
|  | const Eigen::MatrixBase< Derived > & | log,
|  | matrix3_t & | Jlog )

Compute jacobian of function log of rotation matrix in SO(3)

Let us consider a matrix . This functions computes the Jacobian of the function from into that maps to . In other words,

Warning
  Two representations of the angular velocity are possible:
  - or
  - .
  The expression below assumes the second representation is used.

Parameters

  theta | angle of rotation , also ,
  log | 3d vector ,

Return values

  Jlog | matrix .

Todo
  remove this and use pinocchio::Jlog3

## ◆ logSE3()

template<typename Derived >

void hpp::constraints::logSE3 | ( | const Transform3s & | M,
|  | Eigen::MatrixBase< Derived > & | result )
| inline

Compute log of rigid-body transform

Parameters

  M | rigid body transform,

Return values

  theta | angle of rotation,
  result | 6d vector such that the screw motion of linear velocity (of the origin) expressed in the moving frame and of angular velocity expressed in the moving reaches $M$ in unit time.

## ◆ logSO3()

template<typename Derived >

void hpp::constraints::logSO3 | ( | const matrix3_t & | R,
|  | value_type & | theta,
|  | Eigen::MatrixBase< Derived > const & | result )
| inline

Compute log of rotation matrix as a 3d vector

Parameters

  R | rotation matrix in SO(3),

Return values

  theta | angle of rotation,
  result | 3d vector such that

## ◆ matrixToQuat()

template<typename Derived1 , typename Derived2 >

void hpp::constraints::matrixToQuat | ( | const Eigen::MatrixBase< Derived1 > & | M,
|  | Eigen::MatrixBase< Derived2 > const & | q )

## ◆ operator<<()

template<typename Derived >

std::ostream & Eigen::operator<< | ( | std::ostream & | os,
|  | const MatrixBlocksBase< Derived > & | mbi )

## ◆ se3ToConfig()

template<typename Derived >

void hpp::constraints::se3ToConfig | ( | const Transform3s & | M,
|  | Eigen::MatrixBase< Derived > const & | q )